'''
Created on May 24, 2017

@author: root
'''

from __future__ import print_function
import os, logging



def list_files(startpath):
    for root, dirs, files in os.walk(startpath):
        level = root.replace(startpath, '').count(os.sep)
        indent = ' ' * 4 * (level)
        print('{}{}/'.format(indent, os.path.basename(root)))
        subindent = ' ' * 4 * (level + 1)
        for f in files:
            name = f.lower()
            if name.endswith(".shp") or name.endswith(".mdb"):
                print('{}{}'.format(subindent, f))



def get_data_structure(version=3, format="shapefile"):
    #rootDir = os.path.join(os.getcwd(), "template_data")
    rootDir = os.path.join(".", "template_data")
    for single in os.listdir(rootDir):
        ver, form = single.split("_")
        if ver == "v%d" % version and form == format:
            dataStructure = []
            for root, dirs, files in os.walk(os.path.join(rootDir, single)):
                for singleFile in files:
                    name = singleFile.lower()
                    if name.endswith(".shp") or name.endswith(".mdb"):
                        dataStructure.append(os.path.join(root, singleFile).replace(os.path.join(rootDir, single), ""))
            return dataStructure



def createDomain(csv):
    domain = set()
    with open(csv) as f:
        for line in f.readlines()[1:]:
            value = line.split(',')[0]
            domain.add(int(value) if value.isdigit() else value)
    domain = list(domain)
    domain.sort()
    return domain
